Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/DistanceWeightedRecommender.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/DistanceWeightedRecommender.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/DistanceWeightedRecommender.cs	(revision 13787)
@@ -0,0 +1,103 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem.Common {
+  [Item("Distance Weighted Recommender", "")]
+  [StorableClass]
+  public class DistanceWeightedRecommender : ParameterizedNamedItem, IAlgorithmInstanceRecommender {
+
+    private IFixedValueParameter<DoubleValue> NeighborhoodFactorParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["NeighborhoodFactor"]; }
+    }
+
+    public double NeighborhoodFactor {
+      get { return NeighborhoodFactorParameter.Value.Value; }
+      set { NeighborhoodFactorParameter.Value.Value = value; }
+    }
+    
+    [StorableConstructor]
+    private DistanceWeightedRecommender(bool deserializing) : base(deserializing) { }
+    private DistanceWeightedRecommender(DistanceWeightedRecommender original, Cloner cloner)
+      : base(original, cloner) { }
+    public DistanceWeightedRecommender() {
+      Parameters.Add(new FixedValueParameter<DoubleValue>("NeighborhoodFactor", "Penalize neighbors that are far away.", new DoubleValue(5)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DistanceWeightedRecommender(this, cloner);
+    }
+
+    public IRecommendationModel TrainModel(KnowledgeCenter okc, string[] characteristics) {
+      var piDistances = okc.GetProblemDistances(characteristics);
+      var maxDist = piDistances.Max(x => x.Value);
+      var instances = new SortedList<double, IAlgorithm>();
+      foreach (var relevantRuns in okc.GetKnowledgeBaseByAlgorithm()) {
+        var algorithm = relevantRuns.Key;
+        Func<double, double> distFunc = (d) => Math.Exp(NeighborhoodFactor * (-d / maxDist));
+        var pis = relevantRuns.Value.Select(x => ((StringValue)x.Parameters["Problem Name"]).Value).Distinct()
+                              .Select(x => Tuple.Create(x, okc.ProblemInstances.SingleOrDefault(y => ((StringValue)y.Parameters["Problem Name"]).Value == x)))
+                              .Where(x => x.Item2 != null && x.Item2.Parameters.ContainsKey("BestKnownQuality") && piDistances.ContainsKey(x.Item2))
+                              .Select(x => Tuple.Create(x.Item1, distFunc(piDistances[x.Item2]), ((DoubleValue)x.Item2.Parameters["BestKnownQuality"]).Value))
+                              .ToDictionary(x => x.Item1, x => Tuple.Create(x.Item2, x.Item3));
+        var sumPis = pis.Sum(x => x.Value.Item1);
+        var avgERT = 0.0;
+        foreach (var problemRuns in relevantRuns.Value.GroupBy(x => ((StringValue)x.Parameters["Problem Name"]).Value)) {
+          Tuple<double, double> info;
+          if (!pis.TryGetValue(problemRuns.Key, out info)) continue;
+          var convGraph = new List<List<Tuple<double, double>>>();
+          foreach (var run in problemRuns) {
+            var current = new List<Tuple<double, double>>();
+            var performanceGraph = ((IndexedDataTable<double>)run.Results["QualityPerEvaluations"]);
+            current.AddRange(performanceGraph.Rows.First().Values.TakeWhile(v => v.Item1 < okc.MaximumEvaluations.Value));
+            if (current.Count > 0) {
+              current.Add(Tuple.Create((double)okc.MaximumEvaluations.Value, current.Last().Item2));
+              convGraph.Add(current);
+            }
+          }
+          var ert = ExpectedRuntimeHelper.CalculateErt(convGraph, (okc.Maximization ? (1 - okc.MinimumTarget.Value) : (1 + okc.MinimumTarget.Value)) * info.Item2, okc.Maximization).ExpectedRuntime;
+          if (double.IsNaN(ert)) {
+            ert = ExpectedRuntimeHelper.CalculateErt(problemRuns.ToList(), "QualityPerEvaluations", (okc.Maximization ? (1 - okc.MinimumTarget.Value) : (1 + okc.MinimumTarget.Value)) * info.Item2, okc.Maximization).ExpectedRuntime;
+            if (double.IsNaN(ert)) ert = int.MaxValue;
+          }
+          avgERT += info.Item1 * ert;
+        }
+        avgERT /= sumPis;
+        if (instances.ContainsKey(avgERT)) {
+          avgERT += new System.Random().NextDouble();
+        }
+        instances.Add(avgERT, (IAlgorithm)algorithm.Clone());
+      }
+
+      return new FixedRankModel(instances.Select(x => Tuple.Create(x.Value, x.Key)));
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/FixedRankModel.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/FixedRankModel.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/FixedRankModel.cs	(revision 13787)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization;
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.OptimizationExpertSystem.Common {
+  public class FixedRankModel : IRecommendationModel {
+    private List<Tuple<IAlgorithm, double>> ranking;
+
+    public FixedRankModel(IEnumerable<Tuple<IAlgorithm, double>> ranking) {
+      this.ranking = new List<Tuple<IAlgorithm, double>>();
+      foreach (var r in ranking) this.ranking.Add(r);
+    }
+ 
+    public IEnumerable<Tuple<IAlgorithm, double>> GetRanking(KnowledgeCenter kc) { 
+      if (kc.Problem.ProblemId == -1) return new Tuple<IAlgorithm, double>[0];
+      return ranking;
+    }
+
+    public static FixedRankModel GetEmpty() {
+      return new FixedRankModel(new Tuple<IAlgorithm, double>[0]);
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/KNearestNeighborModel.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/KNearestNeighborModel.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/KNearestNeighborModel.cs	(revision 13787)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem.Common {
+  public class KNearestNeighborModel : IRecommendationModel {
+    private readonly int K;
+    private readonly string[] characteristics;
+
+    public KNearestNeighborModel(int k, string[] characteristics) {
+      this.K = k;
+      this.characteristics = characteristics;
+    }
+
+    public IEnumerable<Tuple<IAlgorithm, double>> GetRanking(KnowledgeCenter kc) {
+      var distances = kc.GetProblemDistances(characteristics);
+      var performances = new Dictionary<IAlgorithm, List<double>>();
+      for (var k = 0; k < K; k++) {
+        if (distances.Count == 0) break;
+        var min = distances.MinItems(x => x.Value).First();
+        // lookup algorithm performances in min
+        var perfs = kc.GetAlgorithmPerformance(min.Key);
+        if (perfs.Count == 0) {
+          k--;
+          continue;
+        }
+        foreach (var p in perfs) {
+          var ert = p.Value;
+          if (double.IsNaN(ert)) ert = int.MaxValue;
+          List<double> erts;
+          if (!performances.TryGetValue(p.Key, out erts)) {
+            performances[p.Key] = new List<double>() { ert }; ;
+          } else erts.Add(ert);
+        }
+        distances.Remove(min.Key);
+      }
+
+      return performances.Select(x => new { Alg = x.Key, Perf = x.Value.Average() })
+                         .OrderBy(x => x.Perf)
+                         .Select(x => Tuple.Create(x.Alg, x.Perf));
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/KNearestNeighborRecommender.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/KNearestNeighborRecommender.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/KNearestNeighborRecommender.cs	(revision 13787)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.OptimizationExpertSystem.Common {
+  [Item("K-Nearest Neighbor Recommender", "")]
+  [StorableClass]
+  public sealed class KNearestNeighborRecommender : ParameterizedNamedItem, IAlgorithmInstanceRecommender {
+    
+    private IFixedValueParameter<IntValue> KParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["K"]; }
+    }
+
+    [StorableConstructor]
+    private KNearestNeighborRecommender(bool deserializing) : base(deserializing) { }
+    private KNearestNeighborRecommender(KNearestNeighborRecommender original, Cloner cloner)
+      : base(original, cloner) { }
+    public KNearestNeighborRecommender() {
+      Parameters.Add(new FixedValueParameter<IntValue>("K", "The number of nearest neighbors to consider.", new IntValue(5)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new KNearestNeighborRecommender(this, cloner);
+    }
+
+    public IRecommendationModel TrainModel(KnowledgeCenter kc, string[] characteristics) {
+      return new KNearestNeighborModel(KParameter.Value.Value, characteristics);
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/OverallBestRecommender.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/OverallBestRecommender.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem.Common/3.3/Recommenders/OverallBestRecommender.cs	(revision 13787)
@@ -0,0 +1,84 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem.Common {
+  [Item("Overall Best Recommender", "")]
+  [StorableClass]
+  public class OverallBestRecommender : ParameterizedNamedItem, IAlgorithmInstanceRecommender {
+
+    private IFixedValueParameter<DoubleValue> NeighborhoodFactorParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters["NeighborhoodFactor"]; }
+    }
+
+    public double NeighborhoodFactor {
+      get { return NeighborhoodFactorParameter.Value.Value; }
+      set { NeighborhoodFactorParameter.Value.Value = value; }
+    }
+    
+    [StorableConstructor]
+    private OverallBestRecommender(bool deserializing) : base(deserializing) { }
+    private OverallBestRecommender(OverallBestRecommender original, Cloner cloner)
+      : base(original, cloner) { }
+    public OverallBestRecommender() {
+      Parameters.Add(new FixedValueParameter<DoubleValue>("NeighborhoodFactor", "Penalize neighbors that are far away.", new DoubleValue(5)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OverallBestRecommender(this, cloner);
+    }
+
+    public IRecommendationModel TrainModel(KnowledgeCenter kc, string[] characteristics) {
+      var instances = new List<Tuple<IAlgorithm, double>>();
+      foreach (var relevantRuns in kc.GetKnowledgeBaseByAlgorithm()) {
+        var algorithm = relevantRuns.Key;
+        var pis = relevantRuns.Value.Select(x => ((StringValue)x.Parameters["Problem Name"]).Value).Distinct()
+                              .Select(x => Tuple.Create(x, kc.ProblemInstances.SingleOrDefault(y => ((StringValue)y.Parameters["Problem Name"]).Value == x)))
+                              .Where(x => x.Item2 != null)
+                              .Select(x => Tuple.Create(x.Item1, ((DoubleValue)x.Item2.Parameters["BestKnownQuality"]).Value))
+                              .ToDictionary(x => x.Item1, x => x.Item2);
+        var avgERT = 0.0;
+        var count = 0;
+        foreach (var problemRuns in relevantRuns.Value.GroupBy(x => ((StringValue)x.Parameters["Problem Name"]).Value)) {
+          var bkq = pis[problemRuns.Key];
+          var ert = ExpectedRuntimeHelper.CalculateErt(problemRuns.ToList(), "QualityPerEvaluations", (kc.Maximization ? (1 - kc.MinimumTarget.Value) : (1 + kc.MinimumTarget.Value)) * bkq, kc.Maximization).ExpectedRuntime;
+          if (double.IsNaN(ert)) ert = int.MaxValue;
+          avgERT += ert;
+          count++;
+        }
+        avgERT /= count;
+        instances.Add(Tuple.Create((IAlgorithm)algorithm.Clone(), avgERT));
+      }
+
+      return new FixedRankModel(instances.OrderBy(x => x.Item2));
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj	(revision 13786)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj	(revision 13787)
@@ -191,4 +191,5 @@
       <DependentUpon>AlgorithmControlForm.cs</DependentUpon>
     </Compile>
+    <Compile Include="Menu\200_Solving\210_PerformanceModelingMenuItem.cs" />
     <Compile Include="Toolbar\DownloadFromOKBToolbarItem.cs" />
     <Compile Include="Toolbar\ToolbarItemBase.cs" />
@@ -209,5 +210,5 @@
     <Compile Include="Menu\0_Config\30_DownloadFromOkbMenuItem.cs" />
     <Compile Include="Menu\0_Config\10_SetCredentialsMenuItem.cs" />
-    <Compile Include="Menu\200_Solving\210_SolverMenuItem.cs" />
+    <Compile Include="Menu\200_Solving\220_SolverMenuItem.cs" />
     <Compile Include="Menu\300_Learning\310_KnowledgeBaseMenuItem.cs" />
     <Compile Include="Menu\900_Tools\900_CSharpScriptMenuItem.cs" />
@@ -227,4 +228,10 @@
     </Compile>
     <Compile Include="Plugin.cs" />
+    <Compile Include="Views\PerformanceModelingView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\PerformanceModelingView.Designer.cs">
+      <DependentUpon>PerformanceModelingView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\SolverView.cs">
       <SubType>UserControl</SubType>
@@ -297,4 +304,7 @@
     <EmbeddedResource Include="OptimizationKnowledgeCenter.resx">
       <DependentUpon>OptimizationKnowledgeCenter.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Views\PerformanceModelingView.resx">
+      <DependentUpon>PerformanceModelingView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Views\SolverView.resx">
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/210_PerformanceModelingMenuItem.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/210_PerformanceModelingMenuItem.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/210_PerformanceModelingMenuItem.cs	(revision 13787)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common.Resources;
+using HeuristicLab.MainForm.WindowsForms;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class PerformanceModelingMenuItem : MenuItemBase {
+    public override Image Image { get { return VSImageLibrary.Event; } }
+
+    public override string Name {
+      get { return "Performance Modeling"; }
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Solving" }; }
+    }
+
+    public override int Position {
+      get { return 210; }
+    }
+
+    public override string ToolTipText { get { return "Modeling algorithm performance to suggest well-suited instances."; } }
+
+    public override void Execute() {
+      var viewType = typeof(PerformanceModelingView);
+      var view = MainForm.Views.FirstOrDefault(x => viewType == ((x is ViewHost) ? ((ViewHost)x).ActiveView : x).GetType());
+      if (view != null) view.Show();
+      else MainForm.ShowContent(MainForm.ExpertSystem, viewType);
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/220_SolverMenuItem.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/220_SolverMenuItem.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Menu/200_Solving/220_SolverMenuItem.cs	(revision 13787)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common.Resources;
+using HeuristicLab.MainForm.WindowsForms;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem.Menu {
+  internal class SolverMenuItem : MenuItemBase {
+    public override Image Image { get { return VSImageLibrary.Event; } }
+
+    public override string Name {
+      get { return "Solver"; }
+    }
+
+    public override IEnumerable<string> Structure {
+      get { return new[] { "Solving" }; }
+    }
+
+    public override int Position {
+      get { return 220; }
+    }
+
+    public override string ToolTipText { get { return "Solve the problem instance."; } }
+
+    public override void Execute() {
+      var viewType = typeof(SolverView);
+      var view = MainForm.Views.FirstOrDefault(x => viewType == ((x is ViewHost) ? ((ViewHost)x).ActiveView : x).GetType());
+      if (view != null) view.Show();
+      else MainForm.ShowContent(MainForm.ExpertSystem, viewType);
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/KnowledgeCenterViewBase.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/KnowledgeCenterViewBase.cs	(revision 13786)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/KnowledgeCenterViewBase.cs	(revision 13787)
@@ -48,7 +48,7 @@
       Content.DownloadStarted += ContentOnDownloadStarted;
       Content.AlgorithmInstanceStarted += ContentOnAlgorithmInstanceStarted;
+      Content.RecommendationModelChanged += ContentOnRecommendationModelChanged;
       RegisterContentProblemEvents();
       RegisterContentProblemInstancesEvents();
-      RegisterContentProblemCharacteristicsEvents();
       RegisterContentSolutionSeedingPoolEvents();
       RegisterContentSuggestedInstancesEvents();
@@ -71,12 +71,4 @@
     }
 
-    private void RegisterContentProblemCharacteristicsEvents() {
-      Content.ProblemCharacteristics.ItemsAdded += ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.ItemsReplaced += ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.ItemsRemoved += ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.CheckedItemsChanged += ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.CollectionReset += ContentOnProblemCharacteristicsChanged;
-    }
-
     private void RegisterContentSolutionSeedingPoolEvents() {
       Content.SolutionSeedingPool.CheckedItemsChanged += ContentOnSolutionSeedingPoolChanged;
@@ -88,9 +80,9 @@
 
     private void RegisterContentSuggestedInstancesEvents() {
-      Content.AlgorithmInstances.CollectionReset += ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsAdded += ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsMoved += ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsRemoved += ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsReplaced += ContentOnSuggestedInstancesChanged;
+      Content.AlgorithmInstances.CollectionReset += ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsAdded += ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsMoved += ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsRemoved += ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsReplaced += ContentOnAlgorithmInstancesChanged;
     }
 
@@ -99,7 +91,7 @@
       Content.DownloadStarted -= ContentOnDownloadStarted;
       Content.AlgorithmInstanceStarted -= ContentOnAlgorithmInstanceStarted;
+      Content.RecommendationModelChanged -= ContentOnRecommendationModelChanged;
       DeregisterContentProblemEvents();
       DeregisterContentProblemInstancesEvents();
-      DeregisterContentProblemCharacteristicsEvents();
       DeregisterContentSolutionSeedingPoolEvents();
       DeregisterContentSuggestedInstancesEvents();
@@ -122,12 +114,4 @@
     }
 
-    private void DeregisterContentProblemCharacteristicsEvents() {
-      Content.ProblemCharacteristics.ItemsAdded -= ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.ItemsReplaced -= ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.ItemsRemoved -= ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.CheckedItemsChanged -= ContentOnProblemCharacteristicsChanged;
-      Content.ProblemCharacteristics.CollectionReset -= ContentOnProblemCharacteristicsChanged;
-    }
-
     private void DeregisterContentSolutionSeedingPoolEvents() {
       Content.SolutionSeedingPool.CheckedItemsChanged -= ContentOnSolutionSeedingPoolChanged;
@@ -139,9 +123,9 @@
 
     private void DeregisterContentSuggestedInstancesEvents() {
-      Content.AlgorithmInstances.CollectionReset -= ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsAdded -= ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsMoved -= ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsRemoved -= ContentOnSuggestedInstancesChanged;
-      Content.AlgorithmInstances.ItemsReplaced -= ContentOnSuggestedInstancesChanged;
+      Content.AlgorithmInstances.CollectionReset -= ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsAdded -= ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsMoved -= ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsRemoved -= ContentOnAlgorithmInstancesChanged;
+      Content.AlgorithmInstances.ItemsReplaced -= ContentOnAlgorithmInstancesChanged;
     }
     #endregion
@@ -150,11 +134,11 @@
     protected virtual void OnDownloadEnded() { }
     protected virtual void OnAlgorithmInstanceStarted(IAlgorithm algorithm) { }
+    protected virtual void OnRecommendationModelChanged() { }
     protected virtual void OnPropertyChanged(string propertyName) { }
     protected virtual void OnProblemChanged() { }
     protected virtual void OnProblemSolutionsChanged() { }
     protected virtual void OnProblemInstancesChanged() { }
-    protected virtual void OnProblemCharacteristicsChanged() { }
     protected virtual void OnSolutionSeedingPoolChanged() { }
-    protected virtual void OnSuggestedInstancesChanged() { }
+    protected virtual void OnAlgorithmInstancesChanged() { }
     protected virtual void OnKnowledgeBaseChanged() { }
 
@@ -170,4 +154,9 @@
       if (InvokeRequired) { Invoke((Action<object, EventArgs<IAlgorithm>>)ContentOnAlgorithmInstanceStarted, sender, e); return; }
       OnAlgorithmInstanceStarted(e.Value);
+    }
+
+    private void ContentOnRecommendationModelChanged(object sender, EventArgs e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs<IAlgorithm>>)ContentOnRecommendationModelChanged, sender, e); return; }
+      OnRecommendationModelChanged();
     }
 
@@ -194,9 +183,4 @@
     }
 
-    private void ContentOnProblemCharacteristicsChanged(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action)OnProblemCharacteristicsChanged);
-      else OnProblemCharacteristicsChanged();
-    }
-
     private void ContentOnSolutionSeedingPoolChanged(object sender, EventArgs e) {
       if (InvokeRequired) Invoke((Action)OnSolutionSeedingPoolChanged);
@@ -204,7 +188,7 @@
     }
 
-    private void ContentOnSuggestedInstancesChanged(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action)OnSuggestedInstancesChanged);
-      else OnSuggestedInstancesChanged();
+    private void ContentOnAlgorithmInstancesChanged(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action)OnAlgorithmInstancesChanged);
+      else OnAlgorithmInstancesChanged();
     }
     #endregion
